<?php
namespace Controller;

use Zeedhi\Framework\Controller\Exception;
use Zeedhi\Framework\Report\ReportService;
use Zeedhi\Framework\DTO;

class CustomizationFilesReports extends \Zeedhi\Framework\Controller\Report {

    protected $entityManager;
    protected $qr2Strategy;
    protected $newCode;
    protected $environment;
    protected $connection;
    protected $dataSourceManager;


    public function __construct($reportService, $entityManager, $qr2Strategy, $dataSourceManager) {

        $this->entityManager       = $entityManager;
        $this->qr2Strategy         = $qr2Strategy;
        $this->reportService       = $reportService;
        $this->dataSourceManager   = $dataSourceManager;
        ini_set('default_socket_timeout', 7200);
    }

    /**
     * @param DTO\Request\Row $request
     * @return mixed
     * @throws Exception
     */
    protected function processReport(DTO\Request\Row $request) {
        $row = $request->getRow();
        $reportName = $this->getReportName($row);
        $reportStrategy = $this->getReportStrategy($reportName);
        $parametersRow = $this->prepareParametersRow($reportName, $row);
        return $this->reportService->createRemoteReport($reportStrategy, $reportName, $parametersRow, true);
    }

    protected $reportMapping = array (
        'FAS00510' =>
            array (
                'strategy' => 'QR2',
                'parameterMapping' =>
                    array (
                        "LISTA_FILI" => "P_NRLISTA",
                        "LISTA_TRAB" => "P_NRTRABGERAPERS",
                        "CDCLIENTE" =>"P_CDCLIENTE"
                    )
            )
    );
}
